﻿/* Author: Jim-Kyrre Benjaminsen AKA Romfarer
 * License: This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License. 
 * http://creativecommons.org/licenses/by-nc-nd/3.0/
*/

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using UnityEngine;
using System.Timers;

namespace Romfarer {
    class DebugAssist {

		LazorSystem system { get { return LazorSystemControllerGlobal.ActiveLazorSystem; } }
        LineRenderer testAxisUp; //green
        LineRenderer testAxisRight; //red
        LineRenderer testAxisForward; //blue


        public DebugAssist() {
            //this.system = system;
            testAxisUp = prepareAxis("green", Color.green);
            testAxisRight = prepareAxis("red", Color.red);
            testAxisForward = prepareAxis("blue", Color.blue);

        }


        //TEST BUTTONS......................................................................................................................................................
        public void TestButtons() {
            //TestButtons_AxisOn();
            TestButtons_PrintCams();
            //TestButtons_PrintTargetState();
            //TestButtons_PrintState();
            //TestButtons_Toggle();
            //TestButtons_Test();
            //TestButtons_TestPrint();
            //TestButtons_Test2();
            //TestButtons_Test3();
            //TestButtons_TestRepeat();
            //TestButtons_AlphaFocusTest();
            //FindStuff();
            //FindStuff2();
            //ToggleVector();
            //ToggleVector2();
            //TextFieldThingy();
            //DrawPlanetOverlay();
            //ToggleVectorMap();
            //Rotate();
            //TestButtons_MoveTexture();
			//AdjustMissilePids();
        }

        public void AxisOn() {
            testAxisUp.enabled = true; //green
            testAxisRight.enabled = true; //red
            testAxisForward.enabled = true; //blue
        }

        public void AxisOff() {
            testAxisUp.enabled = false; //green
            testAxisRight.enabled = false; //red
            testAxisForward.enabled = false; //blue
        }

        public void drawAxis(Transform t) {
            testAxisUp.SetPosition(0, t.position); //green
            testAxisUp.SetPosition(1, t.up + t.position);
            testAxisRight.SetPosition(0, t.position); //red
            testAxisRight.SetPosition(1, t.right + t.position);
            testAxisForward.SetPosition(0, t.position); //blue
            testAxisForward.SetPosition(1, t.forward + t.position);
        }

        private LineRenderer prepareAxis(String name, Color color) {
            GameObject lazorTest = new GameObject(name);
            LineRenderer lazorTestRenderer = lazorTest.AddComponent<LineRenderer>();
            lazorTestRenderer.useWorldSpace = true;
            lazorTestRenderer.material = new Material(Shader.Find("Particles/Additive"));
            lazorTestRenderer.SetColors(color, color);
            lazorTestRenderer.SetWidth(0.1f, 0.1f);
            lazorTestRenderer.SetVertexCount(2);
            lazorTestRenderer.SetPosition(0, Vector3.zero);
            lazorTestRenderer.SetPosition(1, Vector3.zero);
            return lazorTestRenderer;
        }

        private bool testButtons_axisOn;
        private void TestButtons_AxisOn() {
        /*    testButtons_axisOn = GUILayout.Toggle(testButtons_axisOn, "AXIS");
            if (testButtons_axisOn) {
                AxisOn();
                drawAxis(system.vessel.transform);
                if (system.Leader != null) system.Leader.TestOn();
                foreach (LazorAimable l in system.Lazors)
                    l.Lazor.TestOn();

            } else {
                AxisOff();
                if (system.Leader != null) system.Leader.TestOff();
                foreach (LazorAimable l in system.Lazors)
                    l.Lazor.TestOff();
            }*/
        }

        private void TestButtons_PrintCams() {
            if (GUILayout.Button("print")) {
                foreach (Camera c in Camera.allCameras) {
                    TestButtons_PrintCamshelper(c);
                    //float[] f = c.layerCullDistances;
                    //print(f[0] + " " + f[1] + " " + f[2] + " " + f[3] + " " + f[4] + " " + f[5] + " " + f[6] + " " + f[7] + " " + f[8] + " " + f[9] + " " + f[10] + " " + f[11] + " " + f[12] + " " + f[13] + " " + f[14] + " " + f[15] + " " + f[16] + " " + f[17] + " " + f[18] + " " + f[19] + " " + f[20] + " " + f[21] + " " + f[22] + " " + f[23] + " " + f[24] + " " + f[25] + " " + f[26] + " " + f[27] + " " + f[28] + " " + f[29] + " " + f[30] + " " + f[31]);
                }
                //print("maincam is: " + Camera.main.name + " + " + (Camera.main == Camera.current));
                //TestButtons_PrintCamshelper(system.guiTargetCam.cam);
                //TestButtons_PrintCamshelper(system.guiTargetCam.cam2);
                //TestButtons_PrintCamshelper(system.guiTargetCam.cam3);
                //TestButtons_PrintCamshelper(PlanetariumCamera.Camera);
                //SkySphereControl ssc = (SkySphereControl)GameObject.FindObjectOfType(typeof(SkySphereControl)); //1
                //MonoBehaviour.print(ssc.dayTimeSpaceColorShift + " -- " + ssc.tgt.name);
                //MonoBehaviour.print(GameObject.FindObjectsOfType(typeof(FlightCamera)).Length); // 1
            }
        }
        private void TestButtons_PrintCamshelper(Camera c) {
            MonoBehaviour.print(c.name + " + " + c.depth + " + " + c.clearFlags + " + " + c.cullingMask + " + " + c.layerCullSpherical + " + " + c.orthographic + " + " + c.hdr + " + " + c.farClipPlane + " + " + c.fov);
            MonoBehaviour.print(c.transform.position + " + " + c.backgroundColor);
        }

        private void TestButtons_PrintTargetState() {
            //print(FlightGlobals.FindObjectsOfTypeIncludingAssets(typeof(OcclusionArea)).Length);
            if (GUILayout.Button("print")) {
                if (system.Target is Vessel) {
                    Vessel v = (Vessel)system.Target;
                    MonoBehaviour.print("Data for Vessel : " + v.vesselName + " ---------------------------");
                    MonoBehaviour.print("v.camera : " + v.camera);
                    MonoBehaviour.print("v.gameObject : " + v.gameObject);
                    MonoBehaviour.print("v.gameObject.layer : " + v.gameObject.layer);
                    MonoBehaviour.print("v.gameObject.camera : " + v.gameObject.camera);
                    MonoBehaviour.print("v.gameObject.renderer : " + v.gameObject.renderer);
                    MonoBehaviour.print("v.IsInvoking() : " + v.IsInvoking());
                    MonoBehaviour.print("v.enabled : " + v.enabled);
                    MonoBehaviour.print("v.hideFlags : " + v.hideFlags);
                    MonoBehaviour.print("v.parts : " + v.parts.Count);
                    MonoBehaviour.print("v.protoVessel : " + v.protoVessel);
                    MonoBehaviour.print("v.state : " + v.state);
                    MonoBehaviour.print("v.situation : " + v.situation);
                    MonoBehaviour.print("v.packed : " + v.packed);
                    MonoBehaviour.print("v.loaded : " + v.loaded);
                    MonoBehaviour.print("v.HoldPhysics : " + v.HoldPhysics);
                    MonoBehaviour.print("v.isCommandable : " + v.isCommandable);
                    MonoBehaviour.print("v.checkVisibility() : " + v.checkVisibility());
                    MonoBehaviour.print("v.GetVesselCrew().Count : " + v.GetVesselCrew().Count);
                    MonoBehaviour.print("v.rootPart.isControllable : " + v.rootPart.isControllable);
					MonoBehaviour.print("v.distanceLandedPackThreshold : " + v.distanceLandedPackThreshold);
					MonoBehaviour.print("v.distancePackThreshold : " + v.distancePackThreshold);
					MonoBehaviour.print("v.distanceLandedUnpackThreshold : " + v.distanceLandedUnpackThreshold);
					MonoBehaviour.print("v.distanceUnpackThreshold : " + v.distanceUnpackThreshold);
                    if (v.renderer != null) {
                        MonoBehaviour.print("v.renderer.isVisible : " + v.renderer.isVisible);
                        MonoBehaviour.print("v.renderer.enabled : " + v.renderer.enabled);
                    }
					MonoBehaviour.print("Part data +++++++++++++++++++++++++++++++++++++");
                    /*foreach (Part p in v.parts) {
                        MonoBehaviour.print("Part : " + p.name + " - - - - - - - - - - - - - - - - -");
                        MonoBehaviour.print("p.rigidbody : " + p.rigidbody);
                        MonoBehaviour.print("p.State : " + p.State);
                        MonoBehaviour.print("p.parent : " + p.parent);
                        MonoBehaviour.print("p.packed : " + p.packed);
                        MonoBehaviour.print("p.frozen : " + p.frozen);
                        MonoBehaviour.print("p.camera : " + p.camera);
                        MonoBehaviour.print("p.renderer : " + p.renderer);
                        MonoBehaviour.print("p.isAttached : " + p.isAttached);
                        MonoBehaviour.print("p.isConnected : " + p.isConnected);
                        MonoBehaviour.print("p.isControllable : " + p.isControllable);
                        MonoBehaviour.print("p.physicalSignificance : " + p.physicalSignificance);
                        MonoBehaviour.print("p.GroundContact : " + p.GroundContact);
                        MonoBehaviour.print("p.angularDrag : " + p.angularDrag);
                        MonoBehaviour.print("p.breakingForce : " + p.breakingForce);
                        MonoBehaviour.print("p.attachMethod : " + p.attachMethod);
                        MonoBehaviour.print("p.dynamicPressureAtm : " + p.dynamicPressureAtm);
                    }*/
                    MonoBehaviour.print("End ----------------------------------------------------------");
                } else if (system.Target is Collider) {
                    Collider v = (Collider)system.Target;
                    if (v.renderer != null) {
                        MonoBehaviour.print("v.renderer.isVisible : " + v.renderer.isVisible);
                        MonoBehaviour.print("v.renderer.enabled : " + v.renderer.enabled);
                    }
                    MonoBehaviour.print("v.camera : " + v.camera);
                    MonoBehaviour.print("v.gameObject : " + v.gameObject);
                    MonoBehaviour.print("v.gameObject.layer : " + v.gameObject.layer);
                    MonoBehaviour.print("v.gameObject.camera : " + v.gameObject.camera);
                    MonoBehaviour.print("v.gameObject.renderer : " + v.gameObject.renderer);
                }
            }
        }

        private void TestButtons_PrintState() {
            if (GUILayout.Button("print self")) {
                Vessel v = system.vessel;
                if (v.renderer != null) {
                    MonoBehaviour.print("v.renderer.isVisible : " + v.renderer.isVisible);
                    MonoBehaviour.print("v.renderer.enabled : " + v.renderer.enabled);
                }
                if (v.rootPart != null) {
                    MonoBehaviour.print("v.rootPart.camera : " + v.rootPart.camera);
                    MonoBehaviour.print("v.rootPart.renderer : " + v.rootPart.renderer);
                }
                MonoBehaviour.print("v.camera : " + v.camera);
                MonoBehaviour.print("v.gameObject : " + v.gameObject);
                MonoBehaviour.print("v.gameObject.layer : " + v.gameObject.layer);
                MonoBehaviour.print("v.gameObject.camera : " + v.gameObject.camera);
                MonoBehaviour.print("v.gameObject.renderer : " + v.gameObject.renderer);
                MonoBehaviour.print("v.IsInvoking() : " + v.IsInvoking());
                MonoBehaviour.print("v.enabled : " + v.enabled);
                MonoBehaviour.print("v.hideFlags : " + v.hideFlags);
                MonoBehaviour.print("v.parts.Count : " + v.parts.Count);
                MonoBehaviour.print("v.protoVessel : " + v.protoVessel);
                MonoBehaviour.print("v.state : " + v.state);
                MonoBehaviour.print("v.packed : " + v.packed);
                MonoBehaviour.print("v.loaded : " + v.loaded);
                MonoBehaviour.print("v.HoldPhysics : " + v.HoldPhysics);
                MonoBehaviour.print("v.isCommandable : " + v.isCommandable);
                MonoBehaviour.print("v.checkVisibility() : " + v.checkVisibility());
                MonoBehaviour.print("v.GetVesselCrew().Count : " + v.GetVesselCrew().Count);
                MonoBehaviour.print("v.rootPart.isControllable : " + v.rootPart.isControllable);
            }
        }

        private bool toggle;
        private void TestButtons_Toggle() {

            toggle = GUILayout.Toggle(toggle, "test toggle");
            if (toggle) {

                if (system.Target != null && system.Target is Vessel && ((Vessel)system.Target).isEVA) {
                    foreach (Part p in ((Vessel)system.Target).parts)
                        if (p.rigidbody != null && p.physicalSignificance == Part.PhysicalSignificance.FULL) {
                            /*double centrifugal = p.rigidbody.mass * (Math.Pow(system.nonRotatingFrameVelocity.magnitude * Math.Cos(system.actualMarkVelocity*Mathf.Deg2Rad), 2)) /
                                    (system.vessel.transform.position - system.vessel.mainBody.position).magnitude;
                            Vector3 centripedal = p.rigidbody.mass * -FlightGlobals.getGeeForceAtPosition(system.target.transform.position);
                            p.rigidbody.AddForce(Vector3.ClampMagnitude(centripedal, centripedal.magnitude - (float)centrifugal) + (p.rigidbody.mass * (system.nonRotatingFrameVelocity - ((Vessel)system.target).orbit.GetVel())));
                            */

                            //p.rigidbody.AddForce(((Vessel)system.target).acceleration * p.rigidbody.mass);
                            //p.rigidbody.AddForce((p.rigidbody.mass * (system.nonRotatingFrameVelocity - ((Vessel)system.target).orbit.GetVel())));  //works vell in vacuum
                            //MonoBehaviour.print(centrifugal.ToString("f3") + " - " + centripedal.magnitude.ToString("f3") + " - " + system.actualMarkVelocity);
                            p.rigidbody.AddForce(p.rigidbody.mass * system.vessel.acceleration - p.rigidbody.mass * FlightGlobals.getGeeForceAtPosition(system.Target.transform.position) + (p.rigidbody.mass * (system.nonRotatingFrameVelocity - ((Vessel)system.Target).orbit.GetVel())));

                        }
                }
            }
        }
        private void TestButtons_Test() {
            if (GUILayout.Button("Test")) {
				/*if(LazorGlobals.manager == null)
					LazorGlobals.manager = (OrbitPhysicsManager)GameObject.FindObjectOfType(typeof(OrbitPhysicsManager));
				MonoBehaviour.print(Vessel.loadDistance+" "+Vessel.unloadDistance+" "+LazorGlobals.manager.distantLandedPartPackThreshold+" "+LazorGlobals.manager.distantPartPackThreshold);
				*/
				//PartmodulePersistenceFix.Sync ();

				//MonoBehaviour.print ( Resources.FindObjectsOfTypeAll(typeof(KerbalEVA)).Length);
				/*MonoBehaviour.print ("parts "+ Resources.FindObjectsOfTypeAll(typeof(Part)).Length);
				MonoBehaviour.print ("vessel "+ Resources.FindObjectsOfTypeAll(typeof(Vessel)).Length);
				foreach(Vessel v in Resources.FindObjectsOfTypeAll(typeof(Vessel)))
					MonoBehaviour.print (v.name);*/

				//MonoBehaviour.print(FlightGlobals.ActiveVessel.rootPart.name + "   " + FlightGlobals.activeTarget.name);
				//MonoBehaviour.print(FlightGlobals.ActiveVessel.rootPart.name + "   " + FlightGlobals.ActiveVessel.ReferenceTransform.name);
				Util.ResetGUI ();
			}
        }
        /*private void TimerTick(object sender, EventArgs e) {
            if (FlightGlobals.ActiveVessel != system.vessel) {
                FlightGlobals.ActiveVessel.SetPosition(system.GetLeader().GetHitPoint());
            }
            timer.Enabled = false;
            timer.Dispose();
        }*/

        private void TestButtons_TestPrint() {
            if (GUILayout.Button("TestPrint")){
                //MonoBehaviour.print(FlightDriver.StateFileToLoad);
                /*MonoBehaviour.print("------------------------------------------");
                foreach (CFG c in system.cfgs) {  //subsystem CFG windows
                        MonoBehaviour.print(c.id + " " + c.rect + " " + c.name + " "+c.enabled.set + " " + c.docked);
                }*/
            }
        }

        private void TestButtons_Test2() {
            if (GUILayout.Button("test2")) {
                /*MonoBehaviour.print("isActive "+system.vessel.mainBody.pqsController.isActive +
                    " isAlive" + system.vessel.mainBody.pqsController.isAlive +
                    " circumference" + system.vessel.mainBody.pqsController.circumference +
                    " collapseAltitudeMax" + system.vessel.mainBody.pqsController.collapseAltitudeMax +
                    " collapseAltitudeValue" + system.vessel.mainBody.pqsController.collapseAltitudeValue +
                    " collapseDelta" + system.vessel.mainBody.pqsController.collapseDelta +
                    " collapseSeaLevelValue" + system.vessel.mainBody.pqsController.collapseSeaLevelValue +
                    " collapseThreshold" + system.vessel.mainBody.pqsController.collapseThreshold +
                    " detailAltitudeMax" + system.vessel.mainBody.pqsController.detailAltitudeMax +
                    " detailAltitudeQuads" + system.vessel.mainBody.pqsController.detailAltitudeQuads +
                    " detailDelta" + system.vessel.mainBody.pqsController.detailDelta +
                    " detailRad" + system.vessel.mainBody.pqsController.detailRad +
                    " detailSeaLevelQuads" + system.vessel.mainBody.pqsController.detailSeaLevelQuads +
                    " horizonAngle" + system.vessel.mainBody.pqsController.horizonAngle +
                    " horizonDistance" + system.vessel.mainBody.pqsController.horizonDistance +
                    " mapMaxHeight" + system.vessel.mainBody.pqsController.mapMaxHeight +
                    " mapOceanHeight" + system.vessel.mainBody.pqsController.mapOceanHeight +
                    " maxDetailDistance" + system.vessel.mainBody.pqsController.maxDetailDistance +
                    " maxLevel" + system.vessel.mainBody.pqsController.maxLevel +
                    " minDetailDistance" + system.vessel.mainBody.pqsController.minDetailDistance +
                    " radius" + system.vessel.mainBody.pqsController.radius +
                    " visibleAltitude" + system.vessel.mainBody.pqsController.visibleAltitude +
                    " visibleRadius" + system.vessel.mainBody.pqsController.visibleRadius +
                    " visRadAltitudeMax" + system.vessel.mainBody.pqsController.visRadAltitudeMax +
                    " visRadAltitudeValue" + system.vessel.mainBody.pqsController.visRadAltitudeValue +
                    "");*/

                /*MonoBehaviour.print(FlightGlobals.activeTarget != null ? FlightGlobals.activeTarget.name : "null");
                MonoBehaviour.print(FlightGlobals.fetch.vesselTargetTransform != null ? FlightGlobals.fetch.vesselTargetTransform.name : "null");
                MonoBehaviour.print(FlightGlobals.fetch.VesselTarget != null ? FlightGlobals.fetch.VesselTarget.GetName() : "null");
                MonoBehaviour.print(FlightDriver.fetch.targetVessel.ToString());*/

                MonoBehaviour.print("------------------------------");
                ITargetable target = FlightGlobals.fetch.VesselTarget;
                MonoBehaviour.print(target != null ? target.GetName() : "null");
                if (target is Vessel)
                    MonoBehaviour.print("is Vessel");
                if (target is ModuleDockingNode)
                    MonoBehaviour.print("is DockingNode");
                

                /*foreach (CFG c in system.cfgs) {  //subsystem CFG windows
                    if (c is CFG_green) {
                        (c as CFG_green).enabled.set = true;
                        (c as CFG_green).docked = false;
                    }
                }*/
            }
        }
        
        private void TestButtons_Test3() {
            if (GUILayout.Button("test3")) {
                //Camera.main.cullingMask = -1 & ~(1 << 0);
                //Camera.main.cullingMask = -1602222592;

                /*MonoBehaviour.print((system.vessel.mainBody.pqsController.GetClampedWorldSurfaceHeight(system.guiSubSystems.surfacePos) - system.vessel.mainBody.Radius) +
                    " " + (system.vessel.mainBody.pqsController.GetClampedWorldAltitude(system.guiSubSystems.surfacePos)) +
                    " " + (system.vessel.mainBody.pqsController.GetSurfaceHeight(system.guiSubSystems.surfacePos) - system.vessel.mainBody.Radius) +
                    " " + (system.vessel.mainBody.pqsController.GetRelativeDistance(system.guiSubSystems.surfacePos)) +
                    " " + (system.vessel.mainBody.pqsController.GetRelativeAltitude(system.guiSubSystems.surfacePos)) +
                    " " + FlightGlobals.ActiveVessel.mainBody.GetAltitude(system.guiSubSystems.surfacePos) +
                    " " + (system.vessel.mainBody.pqsController.radius) +
                    " " + FlightGlobals.ActiveVessel.GetHeightFromTerrain());*/
                //ResourceDisplay.Instance.Update();

                /*MonoBehaviour.print("disabled? "+ResourceDisplay.Instance.displayDisabled);
                foreach (ResourceItem ri in ResourceDisplay.Instance.resourceItems) {
                    ri.Update();
                    MonoBehaviour.print(ri.nameText.Text+" "+ri.vesselResourceCurrent.ToString("f2")+" "+ri.vesselResourceTotal.ToString("f2")+" "+ri.amountText.Text);
                    MonoBehaviour.print(ri.isSelected + " " + ri.mouseOver + " " + ri.showStage);
                }*/
                /*MonoBehaviour.print(((Vessel)system.Target).vesselType.ToString() + " " + ((Vessel)system.Target).rootPart.name);
                foreach (Part p in ((Vessel)system.Target).parts)
                    MonoBehaviour.print("Part "+p.name);*/
                //GameObject.fin.Find("Tracking Station").collider;

                /*MonoBehaviour.print(system.Target.tag + "  " + system.Target.name + "  " + system.Target.GetType() + " " + (system.Target.transform.position - system.vessel.transform.position).magnitude.ToString("f3"));
                if (system.Target is GlobeTerrainCollider)
                    MonoBehaviour.print("GlobeTerrainCollider");
                if (system.Target is PQS_Collider)
                    MonoBehaviour.print("PQS_Collider");
                if (system.Target is PQS_ColliderAdvanced)
                    MonoBehaviour.print("PQS_ColliderAdvanced");
                if (system.Target is PQS_PartCollider)
                    MonoBehaviour.print("PQS_PartCollider");
                if (system.Target is Collider && ((Collider)system.Target).isTrigger)
                    MonoBehaviour.print("isTrigger");
                if (system.Target is Collider)
                    MonoBehaviour.print("bounds " + ((Collider)system.Target).bounds.size.magnitude.ToString("f2"));
                
                MonoBehaviour.print("xxx " + system.Target.transform.name); 
                MonoBehaviour.print("xxx " + system.Target.transform.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.parent.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.parent.parent.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.parent.parent.parent.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.parent.parent.parent.parent.parent.parent.name);
                MonoBehaviour.print("xxx " + system.Target.transform.parent.parent.parent.parent.parent.parent.parent.parent.parent.parent.name);
                Transform t = system.Target.transform.parent.parent.parent.parent.parent.parent.parent.parent.parent.parent;
                MonoBehaviour.print(t.tag + "  " + t.name + "  " + t.GetType() + " " + (t.position - t.position).magnitude.ToString("f3"));
                */

                /*foreach (Camera c in Camera.allCameras) {
                    if (c.name == "Main Camera") {
                        GrayscaleEffect x = c.gameObject.AddComponent<GrayscaleEffect>();
                        x.shader = Shader.Find("Hidden/Grayscale Effect");
                        x.textureRamp = Util.LoadTexture(256, 1, "ramp_grayscale.png");
                    }
                }*/
                
                //working but upside down
                /*GrayscaleEffect x = Camera.mainCamera.gameObject.AddComponent<GrayscaleEffect>();
                x.shader = Shader.Find("Hidden/Grayscale Effect");
                x.textureRamp = Util.LoadTexture(256, 1, "ramp_grayscale.png");*/
                
                /*Material x = new Material(Shader.Find("Hidden/ColorCorrectionCurvesSimple"));
                MonoBehaviour.print(x!=null?"not null":"null");
                MonoBehaviour.print(x.HasProperty("Saturation") ? "Saturation" : "");
                MonoBehaviour.print(x.HasProperty("_Saturation") ? "_Saturation" : "");*/

                string[] a = new string[system.guiController.guiButtons.Count];
                List<GUItab> b = system.guiController.guiButtons.ToList<GUItab>();
                for (int i = 0; i < system.guiController.guiButtons.Count; i++)
                    a[i] = b[i].Name;
                MonoBehaviour.print("xxx " + string.Join("#", a));

                /*GrayscaleEffect x = new GrayscaleEffect();
                x.textureRamp = Util.LoadTexture(256, 1, "ramp_grayscale.png");
                x.shader = Shader.Find("Hidden/Grayscale Effect");
                Camera.mainCamera.SetReplacementShader(x.shader, ""); //null, "RenderType" or "Opaque" yelds no result
                MonoBehaviour.print(x.shader.name);*/

                /*SepiaToneEffect x = Camera.mainCamera.gameObject.AddComponent<SepiaToneEffect>();
                x.shader = Shader.Find("Specular");*/

                
                //Camera.mainCamera.SetReplacementShader(Shader.Find("Self-Illumin/Diffuse"), ""); 


                /*CameraFilter3 x = Camera.mainCamera.gameObject.AddComponent<CameraFilter3>();
                x.init();
                */
                //Camera.mainCamera.SetReplacementShader(Shader.Find("Hidden/Grayscale Effect"), ""); //all gray
                //Camera.mainCamera.gameObject.renderer.material.shader = Shader.Find("Hidden/Grayscale Effect");

                //CameraFilter a = Camera.mainCamera.gameObject.AddComponent<CameraFilter>();
                //a.SetMaterial(CameraModes.Invert);
            }
        }


        private void TestButtons_TestRepeat() {
            if (GUILayout.RepeatButton("testRepeat")) {
                FlightCtrlState ctrlState = new FlightCtrlState();
                if(system.Target!=null && system.Target is Vessel){
                    //ctrlState.activate = true;
                    ctrlState.killRot = false;
                    ctrlState.roll = 1;
                    ctrlState.mainThrottle = 1;
                    ctrlState.X = 1;
                    (system.Target as Vessel).rootPart.propagateControlUpdate(ctrlState);
                    MonoBehaviour.print((system.Target as Vessel).rootPart.isControllable + " " + (system.Target as Vessel).rootPart.packed);
                }
               
            }
        }



        private void FindStuff() {
            if (GUILayout.Button("FindStuff")) {
                /*MonoBehaviour.print("---");
                foreach (GameObject g in UnityEngine.Object.FindObjectsOfType(typeof(GameObject))) {
                    if (g.name == "Tracking Station" || g.name == "Launchpad Platform" || g.name == "Vehicle Assembly Building" || g.name == "SPH" || g.name == "runway")
                        MonoBehaviour.print(g.tag + "  " + g.name + " " + (g.transform.position - system.vessel.transform.position).magnitude.ToString("f3"));
                }*/
                /*MonoBehaviour.print("---find easter eggs---");
                foreach (GameObject g in UnityEngine.Object.FindObjectsOfType(typeof(GameObject))) {
                    if (g.name.Contains("monolith") || g.name.Contains("Monolith") || g.name.Contains("ufo") || g.name.Contains("UFO") || g.name.Contains("memorial") || g.name.Contains("Memorial") || g.name.Contains("Kerbal") || g.name.Contains("Pyramid") || g.name.Contains("face") || g.name.Contains("Cave") || g.name.Contains("Block") || g.name.Contains("Wall") || g.name.Contains("Boulder") || g.name.Contains("MSL") || g.name.Contains("Kraken") || g.name.Contains("Clouds") || g.name.Contains("Statue"))
                        MonoBehaviour.print(g.tag + "  " + g.name + " " + (g.transform.position - system.vessel.transform.position).magnitude.ToString("f3"));
                }*/
				//MonoBehaviour.print("---find stuff---");
				RCSBalancer x = (RCSBalancer)UnityEngine.Object.FindObjectOfType(typeof(RCSBalancer));
				MonoBehaviour.print(x.netThrust + "  "+x.netTorque);

                
            }
        }
        private void FindStuff2() {
            if (GUILayout.Button("FindStuff2")) {
                //Kerbin
                CelestialBody kerbin = LazorGlobals.GetBody("Kerbin");
                MonoBehaviour.print("---");
                foreach (GameObject g in UnityEngine.Object.FindObjectsOfType(typeof(GameObject))) {
                    double distance = (g.transform.position - system.vessel.transform.position).magnitude;
                    double distance_kerbin = (g.transform.position - kerbin.position).magnitude;
                    if ((g.name.Contains("monolith") || g.name.Contains("Monolith")) && distance_kerbin < 1000000)
                        if (g.transform != null)
                            system.targetList.AddExclusive(new GUItargetsListItem("" + g.transform.GetInstanceID(), TargetType.Object, g.transform.name, g.transform, 0, 0));
                        MonoBehaviour.print(g.tag + "  " + g.name + " " + distance.ToString("f3"));
                }


                //add to target list
                /*foreach (GameObject g in UnityEngine.Object.FindObjectsOfType(typeof(GameObject))) {
                    if (g.name.Contains("monolith") || g.name.Contains("Monolith") || g.name.Contains("ufo") || g.name.Contains("UFO") || g.name.Contains("memorial") || g.name.Contains("Memorial") || g.name.Contains("Kerbal") || g.name.Contains("Pyramid") || g.name.Contains("face") || g.name.Contains("Cave") || g.name.Contains("Block") || g.name.Contains("Wall") || g.name.Contains("Boulder") || g.name.Contains("MSL") || g.name.Contains("Kraken") || g.name.Contains("Clouds") || g.name.Contains("Statue")) {
                        MonoBehaviour.print(g.tag + "  " + g.name + " " + (g.transform.position - system.vessel.transform.position).magnitude.ToString("f3"));
                        if (g.collider != null)
                            system.targetList.AddExclusive(new GUItargetsListItem("" + g.collider.GetInstanceID(), TargetType.Object, g.name, g.collider, 0, 0));
                    }
                }*/
            }
        }

        
        private LineRenderer vector;
        private bool toggleVector;
        private void ToggleVector() {
            toggleVector = GUILayout.Toggle(toggleVector, "Toggle Vector");
            if (vector == null) {
                vector = Util.GenericLazor(system.vessel.transform, Vector3.zero, 0.05f, Color.red);
                vector.SetPosition(1, system.vessel.transform.InverseTransformDirection(system.vessel.transform.forward) * 15);
            }
            if (toggleVector) {
                vector.enabled = true;
                /*vector.transform.position = system.vessel.transform.TransformPoint(system.vessel.findLocalCenterOfMass());
                Vector3 gee = FlightGlobals.getGeeForceAtPosition(system.vessel.transform.position);
                if (Vector3.Dot(system.averageAcceleration, system.LocalUp) < 0)
                    vector.transform.forward = system.averageAcceleration + gee;
                else
                    vector.transform.forward = system.averageAcceleration - gee;*/

                vector.transform.position = kerbin.position;
                vector.transform.forward = meshRenderer.bounds.max - kerbin.position;
                
            } else
                vector.enabled = false;
           
            //system.vessel.flightIntegrator.gForce    points straight down
            //system.vessel.flightIntegrator.CentrifugalAcc    points straight up
        }


        private LineRenderer vector2;
        private bool toggleVector2;
        private void ToggleVector2() {
            toggleVector2 = GUILayout.Toggle(toggleVector2, "Toggle Vector2");
            if (vector2 == null) {
                vector2 = Util.GenericLazor(system.vessel.transform, Vector3.zero, 0.05f, Color.yellow);
                vector2.SetPosition(1, system.vessel.transform.InverseTransformDirection(system.vessel.transform.forward) * 15);
            }
            if (toggleVector2) {
                vector2.enabled = true;
                /*vector2.transform.position = system.vessel.transform.TransformPoint(system.vessel.findLocalCenterOfMass());
                vector2.transform.forward = system.averageAcceleration;*/

                vector.transform.position = kerbin.position;
                vector.transform.forward = meshFilter.mesh.bounds.max - kerbin.position;

            } else
                vector2.enabled = false;

            //system.vessel.flightIntegrator.gForce    points straight down
            //system.vessel.flightIntegrator.CentrifugalAcc    points straight up
        }

        float amount;
        private void TextFieldThingy() {
            amount = float.Parse(GUILayout.TextField(amount.ToString("f5"), 5).Replace("\n", "").Replace("\r", ""));
            if(GUILayout.Button("execute textfield")){
                //MonoBehaviour.print(system.RequestResource("LiquidFuel", amount));
                MonoBehaviour.print(system.RequestResource("ElectricCharge", amount));
            }
            
        }

        GameObject planetGO;
        Material planetMat;
        private MeshFilter meshFilter;
        private MeshRenderer meshRenderer;
        Transform kerbin;
        ScaledSpace space;
        private void DrawPlanetOverlay() {
            if (GUILayout.Button("draw overlay")) {
                planetGO = new GameObject("LazorPlanetOverlay");
                space = GameObject.FindObjectsOfType(typeof(ScaledSpace)).OfType<ScaledSpace>().Single();
                kerbin = space.scaledSpaceTransforms.Find(x => x.name == "Kerbin");

                meshFilter = planetGO.AddComponent<MeshFilter>();
                meshFilter.mesh = (Mesh)UnityEngine.Object.Instantiate(kerbin.GetComponent<MeshFilter>().mesh);

                meshRenderer = planetGO.AddComponent<MeshRenderer>();
                planetMat = new Material(Shader.Find("Transparent/Diffuse"));
                planetMat.mainTexture = Util.PlanetTexture;
                meshRenderer.material = planetMat;

                planetGO.layer = space.gameObject.layer;
                planetGO.transform.parent = kerbin;
                planetGO.transform.localScale= new Vector3(1.005f, 1.005f, 1.005f);
                planetGO.transform.position = kerbin.position;
                planetGO.transform.rotation = kerbin.rotation;

                meshFilter.transform.rotation = kerbin.GetComponent<MeshFilter>().transform.rotation;
                meshRenderer.transform.rotation = kerbin.GetComponent<MeshRenderer>().transform.rotation;

                //Rotate the texture to align with global coordinates
                Vector3 v1 = ScaledSpace.LocalToScaledSpace(LazorGlobals.GetBody("Kerbin").GetWorldSurfacePosition(0, 0, 0)) - kerbin.position;
                Vector3 v2 = kerbin.forward;
                float angle = Util.Angle(v1, v2, kerbin.up);
                float offset = angle / 360;
                planetMat.mainTextureOffset = new Vector2(planetMat.mainTextureOffset.x + offset, planetMat.mainTextureOffset.y);
                
                meshRenderer.enabled = true;

                //MonoBehaviour.print(kerbin.GetComponent<MeshRenderer>().material.mainTexture.width + " " + kerbin.GetComponent<MeshRenderer>().material.mainTexture.height);
            }
        }


        private LineRenderer vectorMap;
        private LineRenderer vectorMap2;
        private bool toggleVectorMap;
        private void ToggleVectorMap() {
            toggleVectorMap = GUILayout.Toggle(toggleVectorMap, "Toggle Vector Map");
            if (toggleVectorMap) {
                if (vectorMap == null) {
                    vectorMap = Util.GenericLazor(kerbin, Vector3.zero, 0.05f, Color.red);
                    vectorMap.SetPosition(1, kerbin.InverseTransformDirection(kerbin.forward) * 1000);
                    vectorMap.gameObject.layer = space.gameObject.layer;

                    vectorMap2 = Util.GenericLazor(kerbin, Vector3.zero, 0.05f, Color.green);
                    vectorMap2.SetPosition(1, kerbin.InverseTransformDirection(kerbin.forward) * 1000);
                    vectorMap2.gameObject.layer = space.gameObject.layer;
                }
                vectorMap.enabled = true;
                vectorMap.transform.position = kerbin.position;
                vectorMap.transform.forward = ScaledSpace.LocalToScaledSpace(LazorGlobals.GetBody("Kerbin").GetWorldSurfacePosition(0, 0, 0)) - kerbin.position;

                vectorMap2.enabled = true;
                vectorMap2.transform.position = kerbin.position;
                vectorMap2.transform.forward = kerbin.forward;

            } else if (vectorMap != null) {
                vectorMap.enabled = false;
                vectorMap2.enabled = false;
            }
        }

        /*private void TestButtons_MoveTexture() {
            if (GUILayout.RepeatButton("move texture")) {
                planetMat.mainTextureOffset = new Vector2(planetMat.mainTextureOffset.x + 0.00000001f, planetMat.mainTextureOffset.y);
            }
        }*/

		private float p, i, d;
		private void AdjustMissilePids() {

			system.config.pids.First().Value.pitch.DebugGui2("pid", out p, out i, out d);
			if(GUILayout.Button("reinitialize")) {
				foreach(Config.PidControllers pc in system.config.pids.Values) {
					pc.pitch.Reinitialize(p, i, d);
					pc.yaw.Reinitialize(p, i, d);
				}
			}
		}
    }
}



