﻿/* Author: Jim-Kyrre Benjaminsen AKA Romfarer
 * License: This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License. 
 * http://creativecommons.org/licenses/by-nc-nd/3.0/
*/

using System;
using System.Collections.Generic;
using System.Text;
using UnityEngine;

namespace Romfarer {
	interface IAimable {
		void Aim(Vector3 v);
		Vector3 GetAim();
		Vector3 GetOrigin(); //in world space
	}

	interface IAimableLazor : IAimable{
		void SetControlledStatus(bool cs);
        Transform GetTransform(); //Transform of your aimable object
        Transform GetTransformBase();
        void SetLocalEulerAngles(Vector3 euler); //Transform of your aimable object
        void SetEulerAngles(Vector3 euler); //Transform of your aimable object
        bool LazorIsHittingSomething { get; }
        Vector3 GetHitPoint();
        Texture2D TexLazorCam { get; }
        RaycastHit GetHit();
        float HitDistance();
        Color GetColor();
        //MkII methods
        //void AimAtPoint(Vector3 v);
        //Vector3 GetAimAtPoint();
        //void GetAimState(AimState aimState);
    }
}

/*
public  enum AimState {
    Aiming,
    Aimed,
    Idle,
    Failed
}*/
