﻿/* Author: Jim-Kyrre Benjaminsen AKA Romfarer
 * License: This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License. 
 * http://creativecommons.org/licenses/by-nc-nd/3.0/
*/

using System;
using System.Collections.Generic;
using System.Text;
using UnityEngine;

namespace Romfarer {

    // Really crappy volumetric light class. Nothing to see here!
    class LightCone{

        Transform t;
        Transform u;
        LineRenderer[] cones;
        Vector3 position;
        Color color = Color.black;

        public LightCone(Transform t, Transform u) {
            this.t = t;
            this.u = u;
            cones = new LineRenderer[5];
            cones[0] = DrawConeComponent("" + 0, cones[0], 0.05f, 2.0f, new Vector3(0.0f, 1, 0), u);
            cones[1] = DrawConeComponent("" + 1, cones[1], 0.05f, 1.95f, new Vector3(0.04f, 1, 0), u);
            cones[2] = DrawConeComponent("" + 2, cones[2], 0.05f, 1.9f, new Vector3(0.08f, 1, 0), u);
            cones[3] = DrawConeComponent("" + 3, cones[3], 0.05f, 1.95f, new Vector3(-0.04f, 1, 0), u);
            cones[4] = DrawConeComponent("" + 4, cones[4], 0.05f, 1.9f, new Vector3(-0.08f, 1, 0), u);
        }

        public void SetLocalPosition(Vector3 position) {
            this.position = position;
        }

        public void Initiate() {
            cones[0].SetPosition(1, u.InverseTransformDirection(t.up + new Vector3(t.up.y, t.up.z, t.up.x) * 0.00f) * 4);
            cones[1].SetPosition(1, u.InverseTransformDirection(t.up + new Vector3(t.up.y, t.up.z, t.up.x) * 0.01f) * 4);
            cones[2].SetPosition(1, u.InverseTransformDirection(t.up + new Vector3(t.up.y, t.up.z, t.up.x) * 0.02f) * 4);
            cones[3].SetPosition(1, u.InverseTransformDirection(t.up + new Vector3(t.up.y, t.up.z, t.up.x) * -0.01f) * 4);
            cones[4].SetPosition(1, u.InverseTransformDirection(t.up + new Vector3(t.up.y, t.up.z, t.up.x) * -0.02f) * 4);
        }

        public void SetWidth(float n) {
            
        }
        public void SetMagnitude(float n, float m) {
            cones[0].SetWidth(0.05f, n / 28);
            cones[1].SetWidth(0.05f, n / 28 - 0.025f);
            cones[2].SetWidth(0.05f, n / 28 - 0.05f);
            cones[3].SetWidth(0.05f, n / 28 - 0.025f);
            cones[4].SetWidth(0.05f, n / 28 - 0.05f);
            for (int i = 0; i < cones.Length; i++) {
                cones[i].SetColors(new Color(color.r * (2 - n / 100) * m / 700, color.g * (2 - n / 100) * m / 700, color.b * (2 - n / 100) * m / 700, 0.001f), Color.black);
            }
        }

        private LineRenderer DrawConeComponent(String name, LineRenderer render, float a, float b,Vector3 dir, Transform t) {
            GameObject lazorTest = new GameObject(name);
            render = lazorTest.AddComponent<LineRenderer>();
            render.transform.parent = t;
            render.transform.localEulerAngles = Vector3.zero;
            render.useWorldSpace = false;
            render.transform.localPosition = Vector3.zero;
            render.material = new Material(Shader.Find("Particles/Additive"));
            render.SetColors(new Color(color.r * 0.75f, color.g * 0.75f, color.b * 0.75f, 0.001f), Color.black); //oops
            render.SetWidth(a, b);
            render.SetVertexCount(2);
            render.SetPosition(0, Vector3.zero);
            render.SetPosition(1, Vector3.up);
            return render;
        }

        public void Enable() {
            foreach(LineRenderer c in cones){
               c.enabled = true;
            }
        }

        public void Disable() {
            foreach (LineRenderer c in cones) {
                c.enabled = false;
            }
        }

        public void SetColor(Color c) {
            color = c;
        }
    }
}


// Light
/*lightGameObject = new GameObject("Light"); // Make a game object
spotLight = lightGameObject.AddComponent<Light>(); // Add the light component
spotLight.transform.parent = lazor.transform;
spotLight.transform.localPosition = lazorOriginPoint;
spotLight.transform.forward = lazor.transform.up;
spotLight.type = LightType.Spot;
spotLight.color = Color.red; // Set color and position
spotLight.intensity = 4.0f;
spotLight.range = 30;
spotLight.spotAngle = 25f;
spotLight.renderMode = LightRenderMode.ForcePixel;*/

// Volumetric light
//lightCone = new LightCone(transform, lazor.transform);
